/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

#include "ResourceLoaderAppDirWindows.hpp"
#include "Base/Utils.hpp"
#include <windows.h>
#include <iostream>

namespace OpenVulkano
{
	namespace
	{
		void* HANDLE = ResourceLoader::RegisterResourceLoader(std::make_unique<ResourceLoaderAppDirWindows>());

		std::string FindAppDir()
		{
			char buffer[4096];
			size_t size;
			if ((size = GetModuleFileNameA(NULL, buffer, sizeof(buffer))) > 0)
			{
				std::string_view appDirPath(buffer, size);
				return std::string(appDirPath.substr(0, appDirPath.find_last_of('\\') + 1));
			}
			else
			{
				std::cerr << "Failed to find real path to application!";
			}
			return "";
		}

		const std::string& GetAppDir()
		{
			static const std::string appDirPath = FindAppDir();
			return appDirPath;
		}
	}

	std::string ResourceLoaderAppDirWindows::GetResourcePath(const std::string& resourceName)
	{
		return GetAppDir() + resourceName;
	}

	Array<char> ResourceLoaderAppDirWindows::GetResource(const std::string& resourceName)
	{
		return Utils::ReadFile(GetAppDir() + resourceName);
	}
}